gtkmm: Gtk::TextView Class Reference

gtkmm 2.24.5

Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::TextView Class Reference
Widgets | Container Widgets | TextView Classes

Multi-line text editing widget. More...

Inheritance diagram for Gtk::TextView:
[legend]
Collaboration diagram for Gtk::TextView:
[legend]

## Public Member Functions
virtual | ~TextView ()
GtkTextView* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkTextView* | gobj () const
| Provides access to the underlying C GtkObject. More...
| TextView ()
| TextView (const Glib::RefPtr< TextBuffer >& buffer)
void | set_buffer (const Glib::RefPtr< TextBuffer >& buffer)
| Sets buffer as the buffer being displayed by text_view. More...
Glib::RefPtr< TextBuffer > | get_buffer ()
| Returns the Gtk::TextBuffer being displayed by this text view. More...
Glib::RefPtr< const TextBuffer > | get_buffer () const
| Returns the Gtk::TextBuffer being displayed by this text view. More...
bool | scroll_to_iter (TextBuffer::iterator& iter, double within_margin)
void | scroll_to_mark (const Glib::RefPtr< TextBuffer::Mark >& mark, double within_margin)
void | scroll_mark_onscreen (const Glib::RefPtr< TextBuffer::Mark >& mark)
bool | scroll_to (TextBuffer::iterator& iter, double within_margin=0)
| Scrolls the TextView so that iter is on the screen, by scrolling the minimal distance to get the mark onscreen, possibly not scrolling at all. More...
bool | scroll_to (TextBuffer::iterator& iter, double within_margin, double xalign, double yalign)
| Scrolls the TextView so that iter is on the screen, in the position indicated by xalign and yalign, possibly not scrolling at all. More...
void | scroll_to (const Glib::RefPtr< TextBuffer::Mark >& mark, double within_margin=0)
| Scrolls text_view so that mark is on the screen, by scrolling the minimal distance to get the mark onscreen, possibly not scrolling at all. More...
void | scroll_to (const Glib::RefPtr< TextBuffer::Mark >& mark, double within_margin, double xalign, double yalign)
| Scrolls the TextView so that iter is on the screen, in the position indicated by xalign and yalign, possibly not scrolling at all. More...
bool | move_mark_onscreen (const Glib::RefPtr< TextBuffer::Mark >& mark)
| Moves a mark within the buffer so that it's located within the currently-visible text area. More...
bool | place_cursor_onscreen ()
| Moves the cursor to the currently visible region of the buffer, it it isn't there already. More...
void | get_visible_rect (Gdk::Rectangle& visible_rect) const
| Fills visible_rect with the currently-visible region of the buffer, in buffer coordinates. More...
void | set_cursor_visible (bool setting=true)
| Toggles whether the insertion point is displayed. More...
bool | get_cursor_visible () const
| Find out whether the cursor is being displayed. More...
void | get_iter_location (const TextBuffer::iterator& iter, Gdk::Rectangle& location) const
| Gets a rectangle which roughly contains the character at iter. More...
void | get_iter_at_location (TextBuffer::iterator& iter, int x, int y) const
| Retrieves the iterator at buffer coordinates x and y. More...
void | get_iter_at_position (TextBuffer::iterator& iter, int& trailing, int x, int y) const
| Retrieves the iterator pointing to the character at buffer coordinates x and y. More...
void | get_line_yrange (const TextBuffer::iterator& iter, int& y, int& height) const
| Gets the y coordinate of the top of the line containing iter, and the height of the line. More...
void | get_line_at_y (TextBuffer::iterator& target_iter, int y, int& line_top) const
| Gets the Gtk::TextIter at the start of the line containing the coordinate y. More...
void | buffer_to_window_coords (TextWindowType win, int buffer_x, int buffer_y, int& window_x, int& window_y) const
| Converts coordinate ( buffer_x, buffer_y) to coordinates for the window win, and stores the result in ( window_x, window_y). More...
void | window_to_buffer_coords (TextWindowType win, int window_x, int window_y, int& buffer_x, int& buffer_y) const
| Converts coordinates on the window identified by win to buffer coordinates, storing the result in ( buffer_x, buffer_y). More...
Gtk::Adjustment* | get_hadjustment ()
| Gets the horizontal-scrolling Gtk::Adjustment. More...
const Gtk::Adjustment* | get_hadjustment () const
| Gets the horizontal-scrolling Gtk::Adjustment. More...
Gtk::Adjustment* | get_vadjustment ()
| Gets the vertical-scrolling Gtk::Adjustment. More...
const Gtk::Adjustment* | get_vadjustment () const
| Gets the vertical-scrolling Gtk::Adjustment. More...
Glib::RefPtr< Gdk::Window > | get_window (TextWindowType win)
| Retrieves the Gdk::Window corresponding to an area of the text view; possible windows include the overall widget window, child windows on the left, right, top, bottom, and the window that displays the text buffer. More...
Glib::RefPtr< const Gdk::Window > | get_window (TextWindowType win) const
| Retrieves the Gdk::Window corresponding to an area of the text view; possible windows include the overall widget window, child windows on the left, right, top, bottom, and the window that displays the text buffer. More...
TextWindowType | get_window_type (const Glib::RefPtr< Gdk::Window >& window)
| Usually used to find out which window an event corresponds to. More...
void | set_border_window_size (TextWindowType type, int size)
| Sets the width of Gtk::TEXT_WINDOW_LEFT or Gtk::TEXT_WINDOW_RIGHT, or the height of Gtk::TEXT_WINDOW_TOP or Gtk::TEXT_WINDOW_BOTTOM. More...
int | get_border_window_size (TextWindowType type) const
| Gets the width of the specified border window. More...
bool | forward_display_line (TextBuffer::iterator& iter)
| Moves the given iter forward by one display (wrapped) line. More...
bool | backward_display_line (TextBuffer::iterator& iter)
| Moves the given iter backward by one display (wrapped) line. More...
bool | forward_display_line_end (TextBuffer::iterator& iter)
| Moves the given iter forward to the next display line end. More...
bool | backward_display_line_start (TextBuffer::iterator& iter)
| Moves the given iter backward to the next display line start. More...
bool | starts_display_line (const TextBuffer::iterator& iter)
| Determines whether iter is at the start of a display line. More...
bool | move_visually (TextBuffer::iterator& iter, int count)
| Move the iterator a given number of characters visually, treating it as the strong cursor position. More...
bool | im_context_filter_keypress (GdkEventKey*event)
| Allow the Gtk::TextView input method to internally handle key press and release events. More...
void | reset_im_context ()
| Reset the input method context of the text view if needed. More...
void | add_child_at_anchor (Widget& child, const Glib::RefPtr< TextBuffer::ChildAnchor >& anchor)
| Adds a child widget in the text buffer, at the given anchor. More...
void | add_child_in_window (Widget& child, TextWindowType which_window, int xpos, int ypos)
| Adds a child at fixed coordinates in one of the text widget's windows. More...
void | move_child (Widget& child, int xpos, int ypos)
| Updates the position of a child, as for add_child_in_window(). More...
void | set_wrap_mode (WrapMode wrap_mode)
| Sets the line wrapping for the view. More...
WrapMode | get_wrap_mode () const
| Gets the line wrapping for the view. More...
void | set_editable (bool setting=true)
| Sets the default editability of the Gtk::TextView. More...
bool | get_editable () const
| Returns the default editability of the Gtk::TextView. More...
void | set_pixels_above_lines (int pixels_above_lines)
| Sets the default number of blank pixels above paragraphs in text_view. More...
int | get_pixels_above_lines () const
| Gets the default number of pixels to put above paragraphs. More...
void | set_pixels_below_lines (int pixels_below_lines)
| Sets the default number of pixels of blank space to put below paragraphs in text_view. More...
int | get_pixels_below_lines () const
| Gets the value set by set_pixels_below_lines(). More...
void | set_pixels_inside_wrap (int pixels_inside_wrap)
| Sets the default number of pixels of blank space to leave between display/wrapped lines within a paragraph. More...
int | get_pixels_inside_wrap () const
| Gets the value set by set_pixels_inside_wrap(). More...
void | set_justification (Justification justification)
| Sets the default justification of text in text_view. More...
Justification | get_justification () const
| Gets the default justification of paragraphs in text_view. More...
void | set_left_margin (int left_margin)
| Sets the default left margin for text in text_view. More...
int | get_left_margin () const
| Gets the default left margin size of paragraphs in the text_view. More...
void | set_right_margin (int right_margin)
| Sets the default right margin for text in the text view. More...
int | get_right_margin () const
| Gets the default right margin for text in text_view. More...
void | set_indent (int indent)
| Sets the default indentation for paragraphs in text_view. More...
int | get_indent () const
| Gets the default indentation of paragraphs in text_view. More...
void | set_tabs (Pango::TabArray& tabs)
| Sets the default tab stops for paragraphs in text_view. More...
Pango::TabArray | get_tabs () const
| Gets the default tabs for text_view. More...
TextAttributes | get_default_attributes () const
| Obtains a copy of the default text attributes. More...
void | set_overwrite (bool overwrite=true)
| Changes the Gtk::TextView overwrite mode. More...
bool | get_overwrite () const
| Returns whether the Gtk::TextView is in overwrite mode or not. More...
void | set_accepts_tab (bool accepts_tab=true)
| Sets the behavior of the text widget when the Tab key is pressed. More...
bool | get_accepts_tab () const
| Returns whether pressing the Tab key inserts a tab characters. More...
Glib::SignalProxy< void, Adjustment*, Adjustment*> | signal_set_scroll_adjustments ()
Glib::SignalProxy< void, Menu*> | signal_populate_popup ()
Glib::SignalProxy< void > | signal_set_anchor ()
Glib::SignalProxy< void, const Glib::ustring&> | signal_insert_at_cursor ()
Glib::PropertyProxy< int > | property_pixels_above_lines ()
| Pixels of blank space above paragraphs. More...
Glib::PropertyProxy_ReadOnly< int > | property_pixels_above_lines () const
| Pixels of blank space above paragraphs. More...
Glib::PropertyProxy< int > | property_pixels_below_lines ()
| Pixels of blank space below paragraphs. More...
Glib::PropertyProxy_ReadOnly< int > | property_pixels_below_lines () const
| Pixels of blank space below paragraphs. More...
Glib::PropertyProxy< int > | property_pixels_inside_wrap ()
| Pixels of blank space between wrapped lines in a paragraph. More...
Glib::PropertyProxy_ReadOnly< int > | property_pixels_inside_wrap () const
| Pixels of blank space between wrapped lines in a paragraph. More...
Glib::PropertyProxy< bool > | property_editable ()
| Whether the text can be modified by the user. More...
Glib::PropertyProxy_ReadOnly< bool > | property_editable () const
| Whether the text can be modified by the user. More...
Glib::PropertyProxy< WrapMode > | property_wrap_mode ()
| Whether to wrap lines never, at word boundaries, or at character boundaries. More...
Glib::PropertyProxy_ReadOnly< WrapMode > | property_wrap_mode () const
| Whether to wrap lines never, at word boundaries, or at character boundaries. More...
Glib::PropertyProxy< Justification > | property_justification ()
| Left, right, or center justification. More...
Glib::PropertyProxy_ReadOnly< Justification > | property_justification () const
| Left, right, or center justification. More...
Glib::PropertyProxy< int > | property_left_margin ()
| Width of the left margin in pixels. More...
Glib::PropertyProxy_ReadOnly< int > | property_left_margin () const
| Width of the left margin in pixels. More...
Glib::PropertyProxy< int > | property_right_margin ()
| Width of the right margin in pixels. More...
Glib::PropertyProxy_ReadOnly< int > | property_right_margin () const
| Width of the right margin in pixels. More...
Glib::PropertyProxy< int > | property_indent ()
| Amount to indent the paragraph, in pixels. More...
Glib::PropertyProxy_ReadOnly< int > | property_indent () const
| Amount to indent the paragraph, in pixels. More...
Glib::PropertyProxy< Pango::TabArray > | property_tabs ()
| Custom tabs for this text. More...
Glib::PropertyProxy_ReadOnly< Pango::TabArray > | property_tabs () const
| Custom tabs for this text. More...
Glib::PropertyProxy< bool > | property_cursor_visible ()
| If the insertion cursor is shown. More...
Glib::PropertyProxy_ReadOnly< bool > | property_cursor_visible () const
| If the insertion cursor is shown. More...
Glib::PropertyProxy< Glib::RefPtr< TextBuffer > > | property_buffer ()
| The buffer which is displayed. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TextBuffer > > | property_buffer () const
| The buffer which is displayed. More...
Glib::PropertyProxy< bool > | property_overwrite ()
| Whether entered text overwrites existing contents. More...
Glib::PropertyProxy_ReadOnly< bool > | property_overwrite () const
| Whether entered text overwrites existing contents. More...
Glib::PropertyProxy< bool > | property_accepts_tab ()
| Whether Tab will result in a tab character being entered. More...
Glib::PropertyProxy_ReadOnly< bool > | property_accepts_tab () const
| Whether Tab will result in a tab character being entered. More...
Glib::PropertyProxy< Glib::ustring > | property_im_module ()
| Which IM module should be used. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_im_module () const
| Which IM module should be used. More...
Public Member Functions inherited from Gtk::Container
virtual | ~Container ()
GtkContainer* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkContainer* | gobj () const
| Provides access to the underlying C GtkObject. More...
void | set_border_width (guint border_width)
| Sets the border width of the container. More...
guint | get_border_width () const
| Retrieves the border width of the container. More...
virtual void | add (Widget& widget)
void | remove (Widget& widget)
| Removes widget from container. More...
void | set_resize_mode (ResizeMode resize_mode)
| Sets the resize mode for the container. More...
ResizeMode | get_resize_mode () const
| Returns the resize mode for the container. More...
void | check_resize ()
| Request that contained widgets check their size. More...
void | foreach (const ForeachSlot& slot)
| Operate on contained items This is largely an internal used mainly for things like creating duplicates of internal lists and other such operations. More...
Glib::ListHandle< Widget* > | get_children ()
| (internal) Operate on contained items (see foreach()) More...
Glib::ListHandle< const Widget* > | get_children () const
| Returns the container's non-internal children. More...
void | propagate_expose (Widget& child, GdkEventExpose*event)
| When a container receives an expose event, it must send synthetic expose events to all children that don't have their own Gdk::Windows. More...
void | set_focus_chain (const Glib::ListHandle< Widget*>& focusable_widgets)
| Sets a focus chain, overriding the one computed automatically by GTK+. More...
bool | has_focus_chain () const
Glib::ListHandle< Widget* > | get_focus_chain ()
Glib::ListHandle< const Widget* > | get_focus_chain () const
void | unset_focus_chain ()
| Removes a focus chain explicitly set with set_focus_chain(). More...
void | set_reallocate_redraws (bool needs_redraws=true)
| Sets the reallocate_redraws flag of the container to the given value. More...
void | set_focus_child (Widget& widget)
| Sets the focus on a child. More...
void | set_focus_vadjustment (Adjustment& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Adjustment* | get_focus_vadjustment ()
| Retrieves the vertical focus adjustment for the container. More...
const Adjustment* | get_focus_vadjustment () const
| Retrieves the vertical focus adjustment for the container. More...
void | set_focus_hadjustment (Adjustment& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Adjustment* | get_focus_hadjustment ()
| Retrieves the horizontal focus adjustment for the container. More...
const Adjustment* | get_focus_hadjustment () const
| Retrieves the horizontal focus adjustment for the container. More...
void | resize_children ()
GType | child_type () const
| Returns the type of the children supported by the container. More...
Glib::SignalProxy< void, Widget*> | signal_add ()
Glib::SignalProxy< void, Widget*> | signal_remove ()
Glib::SignalProxy< void > | signal_check_resize ()
Glib::SignalProxy< void, Widget*> | signal_set_focus_child ()
void | show_all_children (bool recursive=true)
Public Member Functions inherited from Gtk::Widget
virtual | ~Widget ()
GtkWidget* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkWidget* | gobj () const
| Provides access to the underlying C GtkObject. More...
bool | set_scroll_adjustments (Adjustment& hadjustment, Adjustment& vadjustment)
| For widgets that support scrolling, sets the scroll adjustments and returns `true`. More...
void | show ()
| Flags a widget to be displayed. More...
void | show_now ()
| Shows a widget. More...
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user). More...
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container). More...
void | hide_all ()
| Recursively hides a widget and any child widgets. More...
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget. More...
void | queue_draw_area (int x, int y, int width, int height)
| Invalidates the rectangular area of widget defined by x, y, width and height by calling gdk_window_invalidate_rect() on the widget's window and all its child windows. More...
void | queue_resize ()
| This function is only for use in widget implementations. More...
Requisition | size_request () const
| This function is typically used when implementing a Gtk::Container subclass. More...
void | size_request (const Requisition& requisition)
| This function is typically used when implementing a Gtk::Container subclass. More...
void | size_allocate (const Allocation& allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets. More...
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated. More...
bool | remove_accelerator (const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator(). More...
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr< AccelGroup >& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated. More...
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal. More...
bool | event (GdkEvent* event)
| Rarely-used function. More...
int | send_expose (GdkEvent*event)
| Very rarely-used function. More...
bool | send_focus_change (GdkEvent*event)
| Sends the focus change event to widget. More...
bool | activate ()
| For widgets that can be "activated" (buttons, menu items, etc.) this function activates them. More...
void | reparent (Widget& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget. More...
bool | intersect (const Gdk::Rectangle& area) const
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection. More...
Gdk::Region | region_intersect (const Gdk::Region& region) const
| Computes the intersection of a widget's area and region, returning the intersection. More...
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget. More...
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the child property child_property on widget. More...
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify(). More...
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus. More...
bool | get_can_focus () const
| Determines whether widget can own the input focus. More...
bool | can_focus () const
| Determines whether widget can own the input focus. More...
bool | has_focus () const
| Determines if the widget has the global input focus. More...
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel. More...
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside. More...
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget. More...
bool | get_can_default () const
| Determines whether widget can be a default widget. More...
bool | can_default () const
| Determines whether widget can be a default widget. More...
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel. More...
void | grab_default ()
| Causes widget to become the default widget. More...
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | get_receives_default () const
| Determines whether widget is alyways treated as default widget withing its toplevel when it has the focus, even if another widget is the default. More...
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse). More...
void | add_modal_grab ()
| Block events to everything else than this widget and its children. More...
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed. More...
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a gtkrc file. More...
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget. More...
void | set_state (StateType state)
| This function is for use in widget implementations. More...
StateType | get_state () const
| Returns the widget's state. More...
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget. More...
bool | get_sensitive () const
| Returns the widget's sensitivity (in the sense of returning the value that has been set using set_sensitive()). More...
bool | is_sensitive () const
| Returns the widget's effective sensitivity, which means it is sensitive itself and also its parent widget is sensntive. More...
void | set_visible (bool visible=true)
| Sets the visibility state of widget. More...
bool | get_visible () const
| Determines whether the widget is visible. More...
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own. More...
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own. More...
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget. More...
bool | get_is_drawable () const
| Determines whether widget can be drawn to. More...
bool | get_realized () const
| Determines whether widget is realized. More...
bool | get_mapped () const
| Whether the widget is mapped. More...
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_expose_event() handler. More...
bool | get_app_paintable () const
| Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_expose_event() handler. More...
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering. More...
bool | get_double_buffered () const
| Determines whether the widget is double buffered. More...
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes. More...
void | set_child_visible (bool is_visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show(). More...
bool | get_child_visible () const
| Gets the value set with set_child_visible(). More...
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a widget's window. More...
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget's window if it is realized, `nullptr` otherwise. More...
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget's window if it is realized, `nullptr` otherwise. More...
Allocation | get_allocation () const
| Retrieves the widget's location. More...
void | set_allocation (const Allocation& allocation)
| Sets the widget's allocation. More...
Container* | get_parent ()
| Returns the parent container of widget. More...
const Container* | get_parent () const
| Returns the parent container of widget. More...
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget's parent window. More...
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget's parent window. More...
void | set_parent_window (const Glib::RefPtr< const Gdk::Window >& parent_window)
| Sets a non default parent window for widget. More...
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order. More...
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary. More...
void | error_bell ()
| Notifies the user about an input-related error on this widget. More...
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget's size request will be width by height. More...
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request(). More...
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget. More...
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget. More...
void | set_extension_events (Gdk::ExtensionMode mode)
| Sets the extension events mask to mode. More...
Gdk::ExtensionMode | get_extension_events () const
| Retrieves the extension events the widget will receive; see gdk_input_set_extension_events(). More...
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type. More...
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type. More...
Glib::RefPtr< Gdk::Colormap > | get_colormap ()
| Gets the colormap that will be used to render widget. More...
Glib::RefPtr< Gdk::Visual > | get_visual ()
| Gets the visual that will be used to render widget. More...
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< Gdk::Window > | get_root_window ()
| Get the root window where this widget is located. More...
Glib::RefPtr< const Gdk::Window > | get_root_window () const
| Get the root window where this widget is located. More...
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings (global property settings, RC file information, etc) used for this widget. More...
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring& selection)
| Returns the clipboard object for the given selection to be used with widget. More...
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring& selection) const
| Returns the clipboard object for the given selection to be used with widget. More...
Glib::RefPtr< Gdk::Pixmap > | get_snapshot (Gdk::Rectangle& clip_rect) const
| Create a Gdk::Pixmap of the contents of the widget and its children. More...
Glib::RefPtr< Gdk::Pixmap > | get_snapshot () const
| Create a Gdk::Pixmap of the contents of the widget and its children. More...
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology. More...
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology. More...
void | set_colormap (const Glib::RefPtr< const Gdk::Colormap >& colormap)
| Sets the colormap for the widget to the given value. More...
Gdk::EventMask | get_events () const
| Returns the event mask for the widget (a bitfield containing flags from the Gdk::EventMask enumeration). More...
void | get_pointer (int& x, int& y) const
| Obtains the location of the mouse pointer in widget coordinates. More...
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers. More...
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations. More...
bool | has_rc_style () const
| Determines if the widget style has been looked up through the rc mechanism. More...
void | set_style (const Glib::RefPtr< Style >& style)
| Sets the Gtk::Style for a widget ( widget->style). More...
void | unset_style ()
void | ensure_style ()
| Ensures that widget has a style ( widget->style). More...
Glib::RefPtr< Style > | get_style ()
| Simply an accessor function that returns widget->style. More...
Glib::RefPtr< const Style > | get_style () const
| Simply an accessor function that returns widget->style. More...
void | modify_style (const Glib::RefPtr< RcStyle >& style)
| Modifies style values on the widget. More...
Glib::RefPtr< RcStyle > | get_modifier_style ()
| Returns the current modifier style for the widget. More...
Glib::RefPtr< const RcStyle > | get_modifier_style () const
| Returns the current modifier style for the widget. More...
void | modify_fg (StateType state, const Gdk::Color& color)
| Sets the foreground color for a widget in a particular state. More...
void | modify_bg (StateType state, const Gdk::Color& color)
| Sets the background color for a widget in a particular state. More...
void | modify_bg_pixmap (StateType state, const Glib::ustring& pixmap_name)
void | modify_text (StateType state, const Gdk::Color& color)
| Sets the text color for a widget in a particular state. More...
void | modify_base (StateType state, const Gdk::Color& color)
| Sets the base color for a widget in a particular state. More...
void | modify_cursor (const Gdk::Color& primary, const Gdk::Color& secondary)
| Sets the cursor color to use in a widget, overriding the cursor_color and secondary_cursor_color style properties. More...
void | unset_cursor ()
| See modify_cursor(). More...
void | modify_font (const Pango::FontDescription& font_desc)
| Sets the font to use for a widget. More...
void | unset_fg (StateType state)
| Undo the effect of previous calls to modify_fg() for a particular state. More...
void | unset_bg (StateType state)
| Undo the effect of previous calls to modify_bg() for a particular state. More...
void | unset_text (StateType state)
| Undo the effect of previous calls to modify_text() for a particular state. More...
void | unset_base (StateType state)
| Undo the effect of previous calls to modify_base() for a particular state. More...
void | unset_font ()
| Undo the effect of previous calls to modify_font() for a particular state. More...
template<class PropertyType >
void | get_style_property (const Glib::ustring& the_property_name, PropertyType& value) const
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Gdk::Pixbuf > | render_icon (const StockID& stock_id, IconSize size, const Glib::ustring& detail=Glib::ustring())
| A convenience function that uses the theme engine and RC file settings for the widget to look up stock_id and render it to a pixbuf. More...
void | set_composite_name (const Glib::ustring& name)
| Sets a widgets composite name. More...
void | unset_composite_name ()
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget. More...
void | reset_rc_styles ()
| Reset the styles of widget and all descendents, so when they are looked up again, they get the correct values for the currently loaded RC file settings. More...
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget. More...
TextDirection | get_direction ()
| Gets the reading direction for a particular widget. More...
TextDirection | get_direction () const
| Gets the reading direction for a particular widget. More...
void | shape_combine_mask (const Glib::RefPtr< const Gdk::Bitmap >& shape_mask, int offset_x, int offset_y)
| Sets a shape for this widget's GDK window. More...
void | unset_shape_combine_mask ()
void | input_shape_combine_mask (const Glib::RefPtr< const Gdk::Bitmap >& shape_mask, int offset_x, int offset_y)
| Sets an input shape for this widget's GDK window. More...
void | unset_input_shape_combine_mask ()
void | reset_shapes ()
| Recursively resets the shape on this widget and its descendants. More...
void | path (Glib::ustring& path, Glib::ustring& path_reversed)
| Compute a widget's path of the form "GtkWindow.MyLabel". More...
void | class_path (Glib::ustring&path, Glib::ustring& path_reversed)
Glib::ListHandle< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is a the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
Glib::ListHandle< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is a the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget. More...
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget. More...
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, Glib::ustring& target, guint32 time)
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::ustring& target, guint32 time)
void | drag_highlight ()
void | drag_unhighlight ()
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const ArrayHandle_TargetEntry& targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set_proxy (const Glib::RefPtr< Gdk::Window >& proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
void | drag_dest_unset ()
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::RefPtr< TargetList >& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE. More...
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
| Returns the list of targets this widget can accept from drag-and-drop. More...
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
| Returns the list of targets this widget can accept from drag-and-drop. More...
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList >& target_list)
| Sets the target types that this widget can accept from drag-and-drop. More...
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag destination. More...
void | drag_source_set (const ArrayHandle_TargetEntry& targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_unset ()
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Colormap >& colormap, const Glib::RefPtr< Gdk::Pixmap >& pixmap, const Glib::RefPtr< Gdk::Bitmap >& mask)
| Sets the icon that will be used for drags from a particular widget from a pixmap/mask. More...
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf. More...
void | drag_source_set_icon (const StockID& stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon. More...
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon. More...
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag source. More...
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag source. More...
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::Selection to the target list of the drag source. More...
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, GdkEvent*event)
| Initiates a drag on the source side. More...
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK+ drag threshold, and thus should trigger the beginning of a drag-and-drop operation. More...
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext >& context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated. More...
bool | get_no_show_all () const
| Returns the current value of the GtkWidget:no-show-all property, which determines whether calls to show_all() and hide_all() will affect this widget. More...
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() and hide_all() will affect this widget. More...
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Container. More...
void | unparent ()
| This function is only for use in widget implementations. More...
void | map ()
| This function is only for use in widget implementations. More...
void | unmap ()
| This function is only for use in widget implementations. More...
void | draw_insertion_cursor (Glib::RefPtr< Gdk::Drawable > drawable, const Gdk::Rectangle& area, const Gdk::Rectangle& location, bool is_primary, TextDirection direction, bool draw_arrow=true)
void | set_tooltip_window (Window& widget)
| Replaces the default, usually yellow, window used for displaying tooltips with widget. More...
Window* | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip. More...
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located. More...
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip. More...
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget. More...
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language. More...
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget. More...
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip. More...
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property. More...
bool | has_no_window () const
bool | is_realized () const
bool | is_mapped () const
bool | is_toplevel () const
bool | is_drawable () const
bool | is_visible () const
bool | sensitive () const
bool | app_paintable () const
bool | receives_default () const
bool | double_buffered () const
bool | parent_sensitive () const
bool | rc_style () const
bool | is_composite_child () const
| Returns trye if the widget is a composite child of its parent. More...
WidgetFlags | get_flags () const
void | set_flags (WidgetFlags flags)
void | unset_flags (WidgetFlags flags)
Gtk::StateType | get_saved_state () const
int | get_width () const
int | get_height () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly. More...
Glib::RefPtr< Action > | get_action ()
| Returns the Gtk::Action that widget is a proxy for. More...
Glib::RefPtr< const Action > | get_action () const
| Returns the Gtk::Action that widget is a proxy for. More...
Requisition | get_requisition () const
| Retrieves the widget's requisition. More...
Glib::SignalProxy< void > | signal_show ()
Glib::SignalProxy< void > | signal_hide ()
Glib::SignalProxy< void > | signal_map ()
| Emitted on mapping of a widget to the screen. More...
Glib::SignalProxy< void > | signal_unmap ()
Glib::SignalProxy< void > | signal_realize ()
| Emitted on realization of a widget. More...
Glib::SignalProxy< void > | signal_unrealize ()
Glib::SignalProxy< void, Requisition*> | signal_size_request ()
Glib::SignalProxy< void, Allocation&> | signal_size_allocate ()
Glib::SignalProxy< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy< void, Widget*> | signal_parent_changed ()
| Informs objects that their parent changed. More...
Glib::SignalProxy< void, Widget*> | signal_hierarchy_changed ()
Glib::SignalProxy< void, const Glib::RefPtr< Gtk::Style >&> | signal_style_changed ()
| The style-set signal is emitted when a new style has been set on a widget. More...
Glib::SignalProxy< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy< void, bool > | signal_grab_notify ()
Glib::SignalProxy< void, GParamSpec*> | signal_child_notify ()
| The ::child-notify signal is emitted for each child property that has changed on an object. More...
Glib::SignalProxy< bool, bool > | signal_mnemonic_activate ()
Glib::SignalProxy< void > | signal_grab_focus ()
Glib::SignalProxy< bool, DirectionType > | signal_focus ()
Glib::SignalProxy< bool, GdkEvent*> | signal_event ()
Glib::SignalProxy< void, GdkEvent*> | signal_event_after ()
Glib::SignalProxy< bool, GdkEventButton*> | signal_button_press_event ()
| Event triggered by user pressing button. More...
Glib::SignalProxy< bool, GdkEventButton*> | signal_button_release_event ()
| Event triggered by user releasing button. More...
Glib::SignalProxy< bool, GdkEventScroll*> | signal_scroll_event ()
Glib::SignalProxy< bool, GdkEventMotion*> | signal_motion_notify_event ()
| Event triggered by user moving pointer. More...
Glib::SignalProxy< bool, GdkEventAny*> | signal_delete_event ()
| The delete_event signal is emitted if a user requests that a toplevel window is closed. More...
Glib::SignalProxy< bool, GdkEventExpose*> | signal_expose_event ()
| Event triggered by window requiring a refresh. More...
Glib::SignalProxy< bool, GdkEventKey*> | signal_key_press_event ()
| Event triggered by a key press will widget has focus. More...
Glib::SignalProxy< bool, GdkEventKey*> | signal_key_release_event ()
| Event triggered by a key release will widget has focus. More...
Glib::SignalProxy< bool, GdkEventCrossing*> | signal_enter_notify_event ()
| Event triggered by pointer entering widget area. More...
Glib::SignalProxy< bool, GdkEventCrossing*> | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area. More...
Glib::SignalProxy< bool, GdkEventConfigure*> | signal_configure_event ()
| Event triggered by a window resizing. More...
Glib::SignalProxy< bool, GdkEventFocus*> | signal_focus_in_event ()
Glib::SignalProxy< bool, GdkEventFocus*> | signal_focus_out_event ()
Glib::SignalProxy< bool, GdkEventAny*> | signal_map_event ()
Glib::SignalProxy< bool, GdkEventAny*> | signal_unmap_event ()
Glib::SignalProxy< bool, GdkEventProperty*> | signal_property_notify_event ()
Glib::SignalProxy< bool, GdkEventSelection*> | signal_selection_clear_event ()
Glib::SignalProxy< bool, GdkEventSelection*> | signal_selection_request_event ()
Glib::SignalProxy< bool, GdkEventSelection*> | signal_selection_notify_event ()
Glib::SignalProxy< bool, GdkEventProximity*> | signal_proximity_in_event ()
Glib::SignalProxy< bool, GdkEventProximity*> | signal_proximity_out_event ()
Glib::SignalProxy< bool, GdkEventVisibility*> | signal_visibility_notify_event ()
Glib::SignalProxy< bool, GdkEventClient*> | signal_client_event ()
Glib::SignalProxy< bool, GdkEventAny*> | signal_no_expose_event ()
Glib::SignalProxy< bool, GdkEventWindowState*> | signal_window_state_event ()
Glib::SignalProxy< void, SelectionData&, guint, guint > | signal_selection_get ()
Glib::SignalProxy< void, const SelectionData&, guint > | signal_selection_received ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&> | signal_drag_begin ()
| The drag_begin signal is emitted on the drag source when a drag is started. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&> | signal_drag_end ()
| The drag_end signal is emitted on the drag source when a drag is finished. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, SelectionData&, guint, guint > | signal_drag_data_get ()
| The drag_data_get signal is emitted on the drag source when the drop site requests the data which is dragged. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&> | signal_drag_data_delete ()
| The drag_data_delete signal is emitted on the drag source when a drag with the action Gdk::ACTION_MOVE is successfully completed. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, DragResult > | signal_drag_failed ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, guint > | signal_drag_leave ()
| The drag_leave signal is emitted on the drop site when the cursor leaves the widget. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, int, int, guint > | signal_drag_motion ()
| The drag_motion signal is emitted on the drop site when the user moves the cursor over the widget during a drag. More...
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, int, int, guint > | signal_drag_drop ()
| The drag_drop signal is emitted on the drop site when the user drops the data onto the widget. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, int, int, const SelectionData&, guint, guint > | signal_drag_data_received ()
| The drag_data_received signal is emitted on the drop site when the dragged data has been received. More...
Glib::SignalProxy< Glib::RefPtr< Atk::Object > > | signal_get_accessible ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::Screen >&> | signal_screen_changed ()
Glib::SignalProxy< void > | signal_composited_changed ()
Glib::SignalProxy< bool > | signal_popup_menu ()
Glib::SignalProxy< bool, int, int, bool, const Glib::RefPtr< Tooltip >&> | signal_query_tooltip ()
Glib::SignalProxy< bool, GdkEventGrabBroken*> | signal_grab_broken_event ()
Glib::SignalProxy< bool, GdkEventExpose*> | signal_damage_event ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget. More...
Glib::PropertyProxy< Container*> | property_parent ()
| The parent widget of this widget. More...
Glib::PropertyProxy_ReadOnly< Container*> | property_parent () const
| The parent widget of this widget. More...
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input. More...
Glib::PropertyProxy< bool > | property_app_paintable ()
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_app_paintable () const
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus. More...
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_default () const
| Whether the widget can be the default widget. More...
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget. More...
Glib::PropertyProxy< bool > | property_receives_default ()
| If `true`, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| If `true`, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_composite_child () const
| Whether the widget is part of a composite widget. More...
Glib::PropertyProxy< Glib::RefPtr< Style > > | property_style ()
| The style of the widget, which contains information about how it will look (colors etc). More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Style > > | property_style () const
| The style of the widget, which contains information about how it will look (colors etc). More...
Glib::PropertyProxy< Gdk::EventMask > | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy_ReadOnly< Gdk::EventMask > | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy< Gdk::ExtensionMode > | property_extension_events ()
| The mask that decides what kind of extension events this widget gets. More...
Glib::PropertyProxy_ReadOnly< Gdk::ExtensionMode > | property_extension_events () const
| The mask that decides what kind of extension events this widget gets. More...
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Whether this widget has a tooltip. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Whether this widget has a tooltip. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| The contents of the tooltip for this widget. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized. More...
Glib::PropertyProxy< bool > | property_no_show_all ()
| Whether Gtk::Widget::show_all() should not affect this widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_no_show_all () const
| Whether Gtk::Widget::show_all() should not affect this widget. More...
Glib::PropertyProxy< bool > | property_double_buffered ()
| Whether or not the widget is double buffered. More...
Glib::PropertyProxy_ReadOnly< bool > | property_double_buffered () const
| Whether or not the widget is double buffered. More...
Public Member Functions inherited from Gtk::Object
virtual | ~Object ()
GtkObject* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkObject* | gobj () const
| Provides access to the underlying C GtkObject. More...
Glib::PropertyProxy< void*> | property_user_data ()
| Anonymous User Data Pointer. More...
Glib::PropertyProxy_ReadOnly< void*> | property_user_data () const
| Anonymous User Data Pointer. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Atk::Implementor
| Implementor (Implementor &&src) noexcept
Implementor & | operator= (Implementor &&src) noexcept
| ~Implementor () noexcept override
AtkImplementor * | gobj ()
const AtkImplementor * | gobj () const
Glib::RefPtr< Atk::Implementor > | wrap (AtkImplementor *object, bool take_copy=false)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Protected Member Functions
virtual void | on_set_scroll_adjustments (Adjustment* hadjustment, Adjustment* vadjustment)
| This is a default handler for the signal signal_set_scroll_adjustments(). More...
virtual void | on_populate_popup (Menu* menu)
| This is a default handler for the signal signal_populate_popup(). More...
virtual void | on_set_anchor ()
| This is a default handler for the signal signal_set_anchor(). More...
virtual void | on_insert_at_cursor (const Glib::ustring& str)
| This is a default handler for the signal signal_insert_at_cursor(). More...
Protected Member Functions inherited from Gtk::Container
virtual void | on_add (Widget* widget)
| This is a default handler for the signal signal_add(). More...
virtual void | on_remove (Widget* widget)
| This is a default handler for the signal signal_remove(). More...
virtual void | on_check_resize ()
| This is a default handler for the signal signal_check_resize(). More...
virtual void | on_set_focus_child (Widget* widget)
| This is a default handler for the signal signal_set_focus_child(). More...
| Container ()
virtual GType | child_type_vfunc () const
virtual void | forall_vfunc (gboolean include_internals, GtkCallback callback, gpointer callback_data)
virtual char* | composite_name_vfunc (GtkWidget* child)
virtual void | set_child_property_vfunc (GtkWidget* child, guint property_id, const GValue* value, GParamSpec* pspec)
virtual void | get_child_property_vfunc (GtkWidget* child, guint property_id, GValue* value, GParamSpec* pspec) const
Glib::PropertyProxy< guint > | property_border_width ()
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy_ReadOnly< guint > | property_border_width () const
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy< ResizeMode > | property_resize_mode ()
| Specify how resize events are handled. More...
Glib::PropertyProxy_ReadOnly< ResizeMode > | property_resize_mode () const
| Specify how resize events are handled. More...
Glib::PropertyProxy_WriteOnly< Widget*> | property_child ()
| Can be used to add a new child to the container. More...
Protected Member Functions inherited from Gtk::Widget
virtual void | on_show ()
| This is a default handler for the signal signal_show(). More...
virtual void | on_hide ()
| This is a default handler for the signal signal_hide(). More...
virtual void | on_map ()
| This is a default handler for the signal signal_map(). More...
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap(). More...
virtual void | on_realize ()
| This is a default handler for the signal signal_realize(). More...
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize(). More...
virtual void | on_size_request (Requisition* requisition)
| This is a default handler for the signal signal_size_request(). More...
virtual void | on_size_allocate (Allocation& allocation)
| This is a default handler for the signal signal_size_allocate(). More...
virtual void | on_state_changed (Gtk::StateType previous_state)
| This is a default handler for the signal signal_state_changed(). More...
virtual void | on_parent_changed (Widget* previous_parent)
| This is a default handler for the signal signal_parent_changed(). More...
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed(). More...
virtual void | on_style_changed (const Glib::RefPtr< Gtk::Style >& previous_style)
| This is a default handler for the signal signal_style_changed(). More...
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed(). More...
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify(). More...
virtual void | on_child_notify (GParamSpec* pspec)
| This is a default handler for the signal signal_child_notify(). More...
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate(). More...
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus(). More...
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus(). More...
virtual bool | on_event (GdkEvent*event)
| This is a default handler for the signal signal_event(). More...
virtual bool | on_button_press_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_press_event(). More...
virtual bool | on_button_release_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_release_event(). More...
virtual bool | on_scroll_event (GdkEventScroll*event)
| This is a default handler for the signal signal_scroll_event(). More...
virtual bool | on_motion_notify_event (GdkEventMotion*event)
| This is a default handler for the signal signal_motion_notify_event(). More...
virtual bool | on_delete_event (GdkEventAny*event)
| This is a default handler for the signal signal_delete_event(). More...
virtual bool | on_expose_event (GdkEventExpose*event)
| This is a default handler for the signal signal_expose_event(). More...
virtual bool | on_key_press_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_press_event(). More...
virtual bool | on_key_release_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_release_event(). More...
virtual bool | on_enter_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_enter_notify_event(). More...
virtual bool | on_leave_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_leave_notify_event(). More...
virtual bool | on_configure_event (GdkEventConfigure*event)
| This is a default handler for the signal signal_configure_event(). More...
virtual bool | on_focus_in_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_in_event(). More...
virtual bool | on_focus_out_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_out_event(). More...
virtual bool | on_map_event (GdkEventAny*event)
| This is a default handler for the signal signal_map_event(). More...
virtual bool | on_unmap_event (GdkEventAny*event)
| This is a default handler for the signal signal_unmap_event(). More...
virtual bool | on_property_notify_event (GdkEventProperty*event)
| This is a default handler for the signal signal_property_notify_event(). More...
virtual bool | on_selection_clear_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_clear_event(). More...
virtual bool | on_selection_request_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_request_event(). More...
virtual bool | on_selection_notify_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_notify_event(). More...
virtual bool | on_proximity_in_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_in_event(). More...
virtual bool | on_proximity_out_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_out_event(). More...
virtual bool | on_visibility_notify_event (GdkEventVisibility*event)
| This is a default handler for the signal signal_visibility_notify_event(). More...
virtual bool | on_client_event (GdkEventClient*event)
| This is a default handler for the signal signal_client_event(). More...
virtual bool | on_no_expose_event (GdkEventAny*event)
| This is a default handler for the signal signal_no_expose_event(). More...
virtual bool | on_window_state_event (GdkEventWindowState*event)
| This is a default handler for the signal signal_window_state_event(). More...
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get(). More...
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
| This is a default handler for the signal signal_selection_received(). More...
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_begin(). More...
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_end(). More...
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext >& context, SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get(). More...
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_data_delete(). More...
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext >& context, guint time)
| This is a default handler for the signal signal_drag_leave(). More...
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion(). More...
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop(). More...
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received(). More...
virtual Glib::RefPtr< Atk::Object > | on_get_accessible ()
| This is a default handler for the signal signal_get_accessible(). More...
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen >& previous_screen)
| This is a default handler for the signal signal_screen_changed(). More...
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual void | show_all_vfunc ()
virtual void | hide_all_vfunc ()
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget. More...
void | unrealize ()
| This function is only useful in widget implementations. More...
void | set_mapped (bool mapped=true)
| Marks the widget as being realized. More...
void | set_realized (bool realized=true)
| Marks the widget as being realized. More...
void | style_attach ()
| This function attaches the widget's Gtk::Style to the widget's Gdk::Window. More...
void | get_child_requisition (Requisition& requisition) const
| This function is only for use in widget implementations. More...
void | get_style_property_value (const Glib::ustring& the_property_name, Glib::ValueBase& value) const
| Gets the value of a style property of widget. More...
void | realize_if_needed ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Atk::Implementor
| Implementor ()
virtual Glib::RefPtr< Object > | ref_accessibile_vfunc ()

## Related Functions
(Note that these are not member functions.)
Gtk::TextView* | wrap (GtkTextView* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Container
Gtk::Container* | wrap (GtkContainer* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Widget
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Object
Gtk::Object* | wrap (GtkObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Container
typedef sigc::slot< void, Widget& > | ForeachSlot
| For instance, void on_foreach(Gtk::Widget* widget);. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Static Public Member Functions inherited from Gtk::Widget
static Widget* | get_current_modal_grab ()
| Retrieve the widget which is currently grabbing all events. More...
static void | push_colormap (const Glib::RefPtr< const Gdk::Colormap >& cmap)
| Pushes cmap onto a global stack of colormaps; the topmost colormap on the stack will be used to create all widgets. More...
static void | pop_colormap ()
| Removes a colormap pushed with push_colormap(). More...
static void | push_composite_child ()
| Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call. More...
static void | pop_composite_child ()
| Cancels the effect of a previous call to push_composite_child(). More...
static void | set_default_colormap (const Glib::RefPtr< const Gdk::Colormap >& colormap)
| Sets the default colormap to use when creating widgets. More...
static Glib::RefPtr< Style > | get_default_style ()
| Returns the default style used by all widgets initially. More...
static Glib::RefPtr< Gdk::Colormap > | get_default_colormap ()
| Obtains the default colormap used to create widgets. More...
static Glib::RefPtr< Gdk::Visual > | get_default_visual ()
| Obtains the visual of the default colormap. More...
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction(). More...
static TextDirection | get_default_direction ()
| Obtains the current default reading direction. More...
static Widget* | drag_get_source_widget (const Glib::RefPtr< Gdk::DragContext >& context)
Static Public Member Functions inherited from Atk::Implementor
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Detailed Description

Multi-line text editing widget.

It displays a Gtk::TextBuffer.

The TextView widget looks like this:

## Constructor & Destructor Documentation

## ◆ ~TextView()

virtual Gtk::TextView::~TextView | ( |  | ) |
| virtual

## ◆ TextView() [1/2]

Gtk::TextView::TextView | ( |  | ) |

## ◆ TextView() [2/2]

Gtk::TextView::TextView | ( | const Glib::RefPtr< TextBuffer >& | buffer | ) |
| explicit

## Member Function Documentation

## ◆ add_child_at_anchor()

void Gtk::TextView::add_child_at_anchor | ( | Widget& | child,
|  | const Glib::RefPtr< TextBuffer::ChildAnchor >& | anchor
| ) |  |

Adds a child widget in the text buffer, at the given anchor.

Parameters

  child | A Gtk::Widget.
  anchor | A Gtk::TextChildAnchor in the Gtk::TextBuffer for text_view.

## ◆ add_child_in_window()

void Gtk::TextView::add_child_in_window | ( | Widget& | child,
|  | TextWindowType | which_window,
|  | int | xpos,
|  | int | ypos
| ) |  |

Adds a child at fixed coordinates in one of the text widget's windows.

The window must have nonzero size (see set_border_window_size()). Note that the child coordinates are given relative to the Gdk::Window in question, and that these coordinates have no sane relationship to scrolling. When placing a child in Gtk::TEXT_WINDOW_WIDGET, scrolling is irrelevant, the child floats above all scrollable areas. But when placing a child in one of the scrollable windows (border windows or text window), you'll need to compute the child's correct position in buffer coordinates any time scrolling occurs or buffer changes occur, and then call move_child() to update the child's position. Unfortunately there's no good way to detect that scrolling has occurred, using the current API; a possible hack would be to update all child positions when the scroll adjustments change or the text buffer changes. See bug 64518 on bugzilla.gnome.org for status of fixing this issue.

Parameters

  child | A Gtk::Widget.
  which_window | Which window the child should appear in.
  xpos | X position of child in window coordinates.
  ypos | Y position of child in window coordinates.

## ◆ backward_display_line()

bool Gtk::TextView::backward_display_line | ( | TextBuffer::iterator& | iter | ) |

Moves the given iter backward by one display (wrapped) line.

A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view's width; paragraphs are the same in all views, since they depend on the contents of the Gtk::TextBuffer.

Parameters

  iter | A Gtk::TextIter.

Returns
  `true` if iter was moved and is not on the end iterator.

## ◆ backward_display_line_start()

bool Gtk::TextView::backward_display_line_start | ( | TextBuffer::iterator& | iter | ) |

Moves the given iter backward to the next display line start.

A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view's width; paragraphs are the same in all views, since they depend on the contents of the Gtk::TextBuffer.

Parameters

  iter | A Gtk::TextIter.

Returns
  `true` if iter was moved and is not on the end iterator.

## ◆ buffer_to_window_coords()

void Gtk::TextView::buffer_to_window_coords | ( | TextWindowType | win,
|  | int | buffer_x,
|  | int | buffer_y,
|  | int & | window_x,
|  | int & | window_y
| ) |  | const

Converts coordinate ( buffer_x, buffer_y) to coordinates for the window win, and stores the result in ( window_x, window_y).

Note that you can't convert coordinates for a nonexisting window (see set_border_window_size()).

Parameters

  win | A Gtk::TextWindowType except Gtk::TEXT_WINDOW_PRIVATE.
  buffer_x | Buffer x coordinate.
  buffer_y | Buffer y coordinate.
  window_x | Window x coordinate return location or `nullptr`.
  window_y | Window y coordinate return location or `nullptr`.

## ◆ forward_display_line()

bool Gtk::TextView::forward_display_line | ( | TextBuffer::iterator& | iter | ) |

Moves the given iter forward by one display (wrapped) line.

A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view's width; paragraphs are the same in all views, since they depend on the contents of the Gtk::TextBuffer.

Parameters

  iter | A Gtk::TextIter.

Returns
  `true` if iter was moved and is not on the end iterator.

## ◆ forward_display_line_end()

bool Gtk::TextView::forward_display_line_end | ( | TextBuffer::iterator& | iter | ) |

Moves the given iter forward to the next display line end.

A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view's width; paragraphs are the same in all views, since they depend on the contents of the Gtk::TextBuffer.

Parameters

  iter | A Gtk::TextIter.

Returns
  `true` if iter was moved and is not on the end iterator.

## ◆ get_accepts_tab()

bool Gtk::TextView::get_accepts_tab | ( |  | ) | const

Returns whether pressing the Tab key inserts a tab characters.

set_accepts_tab().

Since gtkmm 2.4:

Returns
  `true` if pressing the Tab key inserts a tab character, `false` if pressing the Tab key moves the keyboard focus.

## ◆ get_border_window_size()

int Gtk::TextView::get_border_window_size | ( | TextWindowType | type | ) | const

Gets the width of the specified border window.

See set_border_window_size().

Parameters

  type | Window to return size from.

Returns
  Width of window.

## ◆ get_buffer() [1/2]

Glib::RefPtr<TextBuffer> Gtk::TextView::get_buffer | ( |  | ) |

Returns the Gtk::TextBuffer being displayed by this text view.

The reference count on the buffer is not incremented; the caller of this function won't own a new reference.

Returns
  A Gtk::TextBuffer.

## ◆ get_buffer() [2/2]

Glib::RefPtr<const TextBuffer> Gtk::TextView::get_buffer | ( |  | ) | const

Returns the Gtk::TextBuffer being displayed by this text view.

The reference count on the buffer is not incremented; the caller of this function won't own a new reference.

Returns
  A Gtk::TextBuffer.

## ◆ get_cursor_visible()

bool Gtk::TextView::get_cursor_visible | ( |  | ) | const

Find out whether the cursor is being displayed.

Returns
  Whether the insertion mark is visible.

## ◆ get_default_attributes()

TextAttributes Gtk::TextView::get_default_attributes | ( |  | ) | const

Obtains a copy of the default text attributes.

These are the attributes used for text unless a tag overrides them. You'd typically pass the default attributes in to Gtk::TextIter::get_attributes() in order to get the attributes in effect at a given text position.

Returns
  A new Gtk::TextAttributes.

## ◆ get_editable()

bool Gtk::TextView::get_editable | ( |  | ) | const

Returns the default editability of the Gtk::TextView.

Tags in the buffer may override this setting for some ranges of text.

Returns
  Whether text is editable by default.

## ◆ get_hadjustment() [1/2]

Gtk::Adjustment* Gtk::TextView::get_hadjustment | ( |  | ) |

Gets the horizontal-scrolling Gtk::Adjustment.

Since gtkmm 2.22:

Returns
  Pointer to the horizontal Gtk::Adjustment.

## ◆ get_hadjustment() [2/2]

const Gtk::Adjustment* Gtk::TextView::get_hadjustment | ( |  | ) | const

Gets the horizontal-scrolling Gtk::Adjustment.

Since gtkmm 2.22:

Returns
  Pointer to the horizontal Gtk::Adjustment.

## ◆ get_indent()

int Gtk::TextView::get_indent | ( |  | ) | const

Gets the default indentation of paragraphs in text_view.

Tags in the view's buffer may override the default. The indentation may be negative.

Returns
  Number of pixels of indentation.

## ◆ get_iter_at_location()

void Gtk::TextView::get_iter_at_location | ( | TextBuffer::iterator& | iter,
|  | int | x,
|  | int | y
| ) |  | const

Retrieves the iterator at buffer coordinates x and y.

Buffer coordinates are coordinates for the entire buffer, not just the currently-displayed portion. If you have coordinates from an event, you have to convert those to buffer coordinates with window_to_buffer_coords().

Parameters

  iter | A Gtk::TextIter.
  x | X position, in buffer coordinates.
  y | Y position, in buffer coordinates.

## ◆ get_iter_at_position()

void Gtk::TextView::get_iter_at_position | ( | TextBuffer::iterator& | iter,
|  | int & | trailing,
|  | int | x,
|  | int | y
| ) |  | const

Retrieves the iterator pointing to the character at buffer coordinates x and y.

Buffer coordinates are coordinates for the entire buffer, not just the currently-displayed portion. If you have coordinates from an event, you have to convert those to buffer coordinates with window_to_buffer_coords().

Note that this is different from get_iter_at_location(), which returns cursor locations, i.e. positions between characters.

Since gtkmm 2.6:

Parameters

  iter | A Gtk::TextIter.
  trailing | If non-`nullptr`, location to store an integer indicating where in the grapheme the user clicked. It will either be zero, or the number of characters in the grapheme. 0 represents the trailing edge of the grapheme.
  x | X position, in buffer coordinates.
  y | Y position, in buffer coordinates.

## ◆ get_iter_location()

void Gtk::TextView::get_iter_location | ( | const TextBuffer::iterator& | iter,
|  | Gdk::Rectangle& | location
| ) |  | const

Gets a rectangle which roughly contains the character at iter.

The rectangle position is in buffer coordinates; use buffer_to_window_coords() to convert these coordinates to coordinates for one of the windows in the text view.

Parameters

  iter | A Gtk::TextIter.
  location | Bounds of the character at iter.

## ◆ get_justification()

Justification Gtk::TextView::get_justification | ( |  | ) | const

Gets the default justification of paragraphs in text_view.

Tags in the buffer may override the default.

Returns
  Default justification.

## ◆ get_left_margin()

int Gtk::TextView::get_left_margin | ( |  | ) | const

Gets the default left margin size of paragraphs in the text_view.

Tags in the buffer may override the default.

Returns
  Left margin in pixels.

## ◆ get_line_at_y()

void Gtk::TextView::get_line_at_y | ( | TextBuffer::iterator& | target_iter,
|  | int | y,
|  | int & | line_top
| ) |  | const

Gets the Gtk::TextIter at the start of the line containing the coordinate y.

y is in buffer coordinates, convert from window coordinates with window_to_buffer_coords(). If non-`nullptr`, line_top will be filled with the coordinate of the top edge of the line.

Parameters

  target_iter | A Gtk::TextIter.
  y | A y coordinate.
  line_top | Return location for top coordinate of the line.

## ◆ get_line_yrange()

void Gtk::TextView::get_line_yrange | ( | const TextBuffer::iterator& | iter,
|  | int & | y,
|  | int & | height
| ) |  | const

Gets the y coordinate of the top of the line containing iter, and the height of the line.

The coordinate is a buffer coordinate; convert to window coordinates with buffer_to_window_coords().

Parameters

  iter | A Gtk::TextIter.
  y | Return location for a y coordinate.
  height | Return location for a height.

## ◆ get_overwrite()

bool Gtk::TextView::get_overwrite | ( |  | ) | const

Returns whether the Gtk::TextView is in overwrite mode or not.

Since gtkmm 2.4:

Returns
  Whether text_view is in overwrite mode or not.

## ◆ get_pixels_above_lines()

int Gtk::TextView::get_pixels_above_lines | ( |  | ) | const

Gets the default number of pixels to put above paragraphs.

Returns
  Default number of pixels above paragraphs.

## ◆ get_pixels_below_lines()

int Gtk::TextView::get_pixels_below_lines | ( |  | ) | const

Gets the value set by set_pixels_below_lines().

Returns
  Default number of blank pixels below paragraphs.

## ◆ get_pixels_inside_wrap()

int Gtk::TextView::get_pixels_inside_wrap | ( |  | ) | const

Gets the value set by set_pixels_inside_wrap().

Returns
  Default number of pixels of blank space between wrapped lines.

## ◆ get_right_margin()

int Gtk::TextView::get_right_margin | ( |  | ) | const

Gets the default right margin for text in text_view.

Tags in the buffer may override the default.

Returns
  Right margin in pixels.

## ◆ get_tabs()

Pango::TabArray Gtk::TextView::get_tabs | ( |  | ) | const

Gets the default tabs for text_view.

Tags in the buffer may override the defaults. The returned array will be empty if "standard" (8-space) tabs are used.

Returns
  Copy of default tab array, or an empty array if "standard" tabs are used.

## ◆ get_vadjustment() [1/2]

Gtk::Adjustment* Gtk::TextView::get_vadjustment | ( |  | ) |

Gets the vertical-scrolling Gtk::Adjustment.

Since gtkmm 2.22:

Returns
  Pointer to the vertical Gtk::Adjustment.

## ◆ get_vadjustment() [2/2]

const Gtk::Adjustment* Gtk::TextView::get_vadjustment | ( |  | ) | const

Gets the vertical-scrolling Gtk::Adjustment.

Since gtkmm 2.22:

Returns
  Pointer to the vertical Gtk::Adjustment.

## ◆ get_visible_rect()

void Gtk::TextView::get_visible_rect | ( | Gdk::Rectangle& | visible_rect | ) | const

Fills visible_rect with the currently-visible region of the buffer, in buffer coordinates.

Convert to window coordinates with buffer_to_window_coords().

Parameters

  visible_rect | Rectangle to fill.

## ◆ get_window() [1/2]

Glib::RefPtr<Gdk::Window> Gtk::TextView::get_window | ( | TextWindowType | win | ) |

Retrieves the Gdk::Window corresponding to an area of the text view; possible windows include the overall widget window, child windows on the left, right, top, bottom, and the window that displays the text buffer.

Windows are `nullptr` and nonexistent if their width or height is 0, and are nonexistent before the widget has been realized.

Parameters

  win | Window to get.

Returns
  A Gdk::Window, or `nullptr`.

## ◆ get_window() [2/2]

Glib::RefPtr<const Gdk::Window> Gtk::TextView::get_window | ( | TextWindowType | win | ) | const

Retrieves the Gdk::Window corresponding to an area of the text view; possible windows include the overall widget window, child windows on the left, right, top, bottom, and the window that displays the text buffer.

Windows are `nullptr` and nonexistent if their width or height is 0, and are nonexistent before the widget has been realized.

Parameters

  win | Window to get.

Returns
  A Gdk::Window, or `nullptr`.

## ◆ get_window_type()

TextWindowType Gtk::TextView::get_window_type | ( | const Glib::RefPtr< Gdk::Window >& | window | ) |

Usually used to find out which window an event corresponds to.

If you connect to an event signal on text_view, this function should be called on `event->window` to see which window it was.

Parameters

  window | A window type.

Returns
  The window type.

## ◆ get_wrap_mode()

WrapMode Gtk::TextView::get_wrap_mode | ( |  | ) | const

Gets the line wrapping for the view.

Returns
  The line wrap setting.

## ◆ gobj() [1/2]

GtkTextView* Gtk::TextView::gobj | ( |  | ) |
| inline

Provides access to the underlying C GtkObject.

## ◆ gobj() [2/2]

const GtkTextView* Gtk::TextView::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GtkObject.

## ◆ im_context_filter_keypress()

bool Gtk::TextView::im_context_filter_keypress | ( | GdkEventKey * | event | ) |

Allow the Gtk::TextView input method to internally handle key press and release events.

If this function returns `true`, then no further processing should be done for this key event. See gtk_im_context_filter_keypress().

Note that you are expected to call this function from your handler when overriding key event handling. This is needed in the case when you need to insert your own key handling between the input method and the default key event handling of the Gtk::TextView.

[C example ellipted]

Since gtkmm 2.22:

Parameters

  event | The key event.

Returns
  `true` if the input method handled the key event.

## ◆ move_child()

void Gtk::TextView::move_child | ( | Widget& | child,
|  | int | xpos,
|  | int | ypos
| ) |  |

Updates the position of a child, as for add_child_in_window().

Parameters

  child | Child widget already added to the text view.
  xpos | New X position in window coordinates.
  ypos | New Y position in window coordinates.

## ◆ move_mark_onscreen()

bool Gtk::TextView::move_mark_onscreen | ( | const Glib::RefPtr< TextBuffer::Mark >& | mark | ) |

Moves a mark within the buffer so that it's located within the currently-visible text area.

Parameters

  mark | A Gtk::TextMark.

Returns
  `true` if the mark moved (wasn't already onscreen).

## ◆ move_visually()

bool Gtk::TextView::move_visually | ( | TextBuffer::iterator& | iter,
|  | int | count
| ) |  |

Move the iterator a given number of characters visually, treating it as the strong cursor position.

If count is positive, then the new strong cursor position will be count positions to the right of the old cursor position. If count is negative then the new strong cursor position will be count positions to the left of the old cursor position.

In the presence of bi-directional text, the correspondence between logical and visual order will depend on the direction of the current run, and there may be jumps when the cursor is moved off of the end of a run.

Parameters

  iter | A Gtk::TextIter.
  count | Number of characters to move (negative moves left, positive moves right).

Returns
  `true` if iter moved and is not on the end iterator.

## ◆ on_insert_at_cursor()

virtual void Gtk::TextView::on_insert_at_cursor | ( | const Glib::ustring & | str | ) |
| protectedvirtual

This is a default handler for the signal signal_insert_at_cursor().

## ◆ on_populate_popup()

virtual void Gtk::TextView::on_populate_popup | ( | Menu* | menu | ) |
| protectedvirtual

This is a default handler for the signal signal_populate_popup().

## ◆ on_set_anchor()

virtual void Gtk::TextView::on_set_anchor | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_set_anchor().

## ◆ on_set_scroll_adjustments()

virtual void Gtk::TextView::on_set_scroll_adjustments | ( | Adjustment* | hadjustment,
|  | Adjustment* | vadjustment
| ) |  |
| protectedvirtual

This is a default handler for the signal signal_set_scroll_adjustments().

## ◆ place_cursor_onscreen()

bool Gtk::TextView::place_cursor_onscreen | ( |  | ) |

Moves the cursor to the currently visible region of the buffer, it it isn't there already.

Returns
  `true` if the cursor had to be moved.

## ◆ property_accepts_tab() [1/2]

Glib::PropertyProxy< bool > Gtk::TextView::property_accepts_tab | ( |  | ) |

Whether Tab will result in a tab character being entered.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_accepts_tab() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextView::property_accepts_tab | ( |  | ) | const

Whether Tab will result in a tab character being entered.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_buffer() [1/2]

Glib::PropertyProxy< Glib::RefPtr<TextBuffer> > Gtk::TextView::property_buffer | ( |  | ) |

The buffer which is displayed.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_buffer() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TextBuffer> > Gtk::TextView::property_buffer | ( |  | ) | const

The buffer which is displayed.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_cursor_visible() [1/2]

Glib::PropertyProxy< bool > Gtk::TextView::property_cursor_visible | ( |  | ) |

If the insertion cursor is shown.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_cursor_visible() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextView::property_cursor_visible | ( |  | ) | const

If the insertion cursor is shown.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_editable() [1/2]

Glib::PropertyProxy< bool > Gtk::TextView::property_editable | ( |  | ) |

Whether the text can be modified by the user.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_editable() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextView::property_editable | ( |  | ) | const

Whether the text can be modified by the user.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_im_module() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::TextView::property_im_module | ( |  | ) |

Which IM module should be used.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_im_module() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::TextView::property_im_module | ( |  | ) | const

Which IM module should be used.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_indent() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_indent | ( |  | ) |

Amount to indent the paragraph, in pixels.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_indent() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_indent | ( |  | ) | const

Amount to indent the paragraph, in pixels.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_justification() [1/2]

Glib::PropertyProxy< Justification > Gtk::TextView::property_justification | ( |  | ) |

Left, right, or center justification.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_justification() [2/2]

Glib::PropertyProxy_ReadOnly< Justification > Gtk::TextView::property_justification | ( |  | ) | const

Left, right, or center justification.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_left_margin() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_left_margin | ( |  | ) |

Width of the left margin in pixels.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_left_margin() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_left_margin | ( |  | ) | const

Width of the left margin in pixels.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_overwrite() [1/2]

Glib::PropertyProxy< bool > Gtk::TextView::property_overwrite | ( |  | ) |

Whether entered text overwrites existing contents.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_overwrite() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextView::property_overwrite | ( |  | ) | const

Whether entered text overwrites existing contents.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_above_lines() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_pixels_above_lines | ( |  | ) |

Pixels of blank space above paragraphs.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_above_lines() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_pixels_above_lines | ( |  | ) | const

Pixels of blank space above paragraphs.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_below_lines() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_pixels_below_lines | ( |  | ) |

Pixels of blank space below paragraphs.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_below_lines() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_pixels_below_lines | ( |  | ) | const

Pixels of blank space below paragraphs.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_inside_wrap() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_pixels_inside_wrap | ( |  | ) |

Pixels of blank space between wrapped lines in a paragraph.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_inside_wrap() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_pixels_inside_wrap | ( |  | ) | const

Pixels of blank space between wrapped lines in a paragraph.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_right_margin() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_right_margin | ( |  | ) |

Width of the right margin in pixels.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_right_margin() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_right_margin | ( |  | ) | const

Width of the right margin in pixels.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_tabs() [1/2]

Glib::PropertyProxy< Pango::TabArray > Gtk::TextView::property_tabs | ( |  | ) |

Custom tabs for this text.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_tabs() [2/2]

Glib::PropertyProxy_ReadOnly< Pango::TabArray > Gtk::TextView::property_tabs | ( |  | ) | const

Custom tabs for this text.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_wrap_mode() [1/2]

Glib::PropertyProxy< WrapMode > Gtk::TextView::property_wrap_mode | ( |  | ) |

Whether to wrap lines never, at word boundaries, or at character boundaries.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_wrap_mode() [2/2]

Glib::PropertyProxy_ReadOnly< WrapMode > Gtk::TextView::property_wrap_mode | ( |  | ) | const

Whether to wrap lines never, at word boundaries, or at character boundaries.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ reset_im_context()

void Gtk::TextView::reset_im_context | ( |  | ) |

Reset the input method context of the text view if needed.

This can be necessary in the case where modifying the buffer would confuse on-going input method behavior.

Since gtkmm 2.22:

## ◆ scroll_mark_onscreen()

void Gtk::TextView::scroll_mark_onscreen | ( | const Glib::RefPtr< TextBuffer::Mark >& | mark | ) |

Deprecated:
  Use scroll_to()

## ◆ scroll_to() [1/4]

bool Gtk::TextView::scroll_to | ( | TextBuffer::iterator& | iter,
|  | double | within_margin = `0`
| ) |  |

Scrolls the TextView so that iter is on the screen, by scrolling the minimal distance to get the mark onscreen, possibly not scrolling at all.

The effective screen for purposes of this function is reduced by a margin of size within_margin.

Note
  This function uses the currently-computed height of the lines in the text buffer. Note that line heights are computed in an idle handler; so this function may not have the desired effect if it's called before the height computations. To avoid oddness, consider using gtk_text_view_scroll_to_mark() which saves a point to be scrolled to after line validation.

Parameters

  iter | An iterator pointing to the position that should be made visible by scrolling.
  within_margin | margin as a [0.0,0.5] fraction of screen size.

Returns
  true if scrolling occurred.

## ◆ scroll_to() [2/4]

bool Gtk::TextView::scroll_to | ( | TextBuffer::iterator& | iter,
|  | double | within_margin,
|  | double | xalign,
|  | double | yalign
| ) |  |

Scrolls the TextView so that iter is on the screen, in the position indicated by xalign and yalign, possibly not scrolling at all.

The effective screen for purposes of this function is reduced by a margin of size within_margin.

Note
  This function uses the currently-computed height of the lines in the text buffer. Note that line heights are computed in an idle handler; so this function may not have the desired effect if it's called before the height computations. To avoid oddness, consider using gtk_text_view_scroll_to_mark() which saves a point to be scrolled to after line validation.

Parameters

  iter | An iterator pointing to the position that should be made visible by scrolling.
  within_margin | margin as a [0.0,0.5] fraction of screen size.
  xalign | horizontal alignment of mark within visible area. An alignment of 0.0 indicates left, 1.0 indicates right, 0.5 means center.
  yalign | vertical alignment of mark within visible area. An alignment of 0.0 indicates top, 1.0 indicates bottom, 0.5 means center.

Returns
  true if scrolling occurred.

## ◆ scroll_to() [3/4]

void Gtk::TextView::scroll_to | ( | const Glib::RefPtr< TextBuffer::Mark >& | mark,
|  | double | within_margin = `0`
| ) |  |

Scrolls text_view so that mark is on the screen, by scrolling the minimal distance to get the mark onscreen, possibly not scrolling at all.

The effective screen for purposes of this function is reduced by a margin of size within_margin.

Parameters

  mark | An mark pointing to the position that should be made visible by scrolling.
  within_margin | margin as a [0.0,0.5] fraction of screen size.

## ◆ scroll_to() [4/4]

void Gtk::TextView::scroll_to | ( | const Glib::RefPtr< TextBuffer::Mark >& | mark,
|  | double | within_margin,
|  | double | xalign,
|  | double | yalign
| ) |  |

Scrolls the TextView so that iter is on the screen, in the position indicated by xalign and yalign, possibly not scrolling at all.

The effective screen for purposes of this function is reduced by a margin of size within_margin.

Parameters

  mark | An mark pointing to the position that should be made visible by scrolling.
  within_margin | margin as a [0.0,0.5] fraction of screen size.
  xalign | horizontal alignment of mark within visible area. An alignment of 0.0 indicates left, 1.0 indicates right, 0.5 means center.
  yalign | vertical alignment of mark within visible area. An alignment of 0.0 indicates top, 1.0 indicates bottom, 0.5 means center.

## ◆ scroll_to_iter()

bool Gtk::TextView::scroll_to_iter | ( | TextBuffer::iterator& | iter,
|  | double | within_margin
| ) |  |

Deprecated:
  Use scroll_to().

## ◆ scroll_to_mark()

void Gtk::TextView::scroll_to_mark | ( | const Glib::RefPtr< TextBuffer::Mark >& | mark,
|  | double | within_margin
| ) |  |

Deprecated:
  Use scroll_to().

## ◆ set_accepts_tab()

void Gtk::TextView::set_accepts_tab | ( | bool | accepts_tab = `true` | ) |

Sets the behavior of the text widget when the Tab key is pressed.

If accepts_tab is `true`, a tab character is inserted. If accepts_tab is `false` the keyboard focus is moved to the next widget in the focus chain.

Since gtkmm 2.4:

Parameters

  accepts_tab | `true` if pressing the Tab key should insert a tab character, `false`, if pressing the Tab key should move the keyboard focus.

## ◆ set_border_window_size()

void Gtk::TextView::set_border_window_size | ( | TextWindowType | type,
|  | int | size
| ) |  |

Sets the width of Gtk::TEXT_WINDOW_LEFT or Gtk::TEXT_WINDOW_RIGHT, or the height of Gtk::TEXT_WINDOW_TOP or Gtk::TEXT_WINDOW_BOTTOM.

Automatically destroys the corresponding window if the size is set to 0, and creates the window if the size is set to non-zero. This function can only be used for the "border windows," it doesn't work with Gtk::TEXT_WINDOW_WIDGET, Gtk::TEXT_WINDOW_TEXT, or Gtk::TEXT_WINDOW_PRIVATE.

Parameters

  type | Window to affect.
  size | Width or height of the window.

## ◆ set_buffer()

void Gtk::TextView::set_buffer | ( | const Glib::RefPtr< TextBuffer >& | buffer | ) |

Sets buffer as the buffer being displayed by text_view.

The previous buffer displayed by the text view is unreferenced, and a reference is added to buffer. If you owned a reference to buffer before passing it to this function, you must remove that reference yourself; Gtk::TextView will not "adopt" it.

Parameters

  buffer | A Gtk::TextBuffer.

## ◆ set_cursor_visible()

void Gtk::TextView::set_cursor_visible | ( | bool | setting = `true` | ) |

Toggles whether the insertion point is displayed.

A buffer with no editable text probably shouldn't have a visible cursor, so you may want to turn the cursor off.

Parameters

  setting | Whether to show the insertion cursor.

## ◆ set_editable()

void Gtk::TextView::set_editable | ( | bool | setting = `true` | ) |

Sets the default editability of the Gtk::TextView.

You can override this default setting with tags in the buffer, using the "editable" attribute of tags.

Parameters

  setting | Whether it's editable.

## ◆ set_indent()

void Gtk::TextView::set_indent | ( | int | indent | ) |

Sets the default indentation for paragraphs in text_view.

Tags in the buffer may override the default.

Parameters

  indent | Indentation in pixels.

## ◆ set_justification()

void Gtk::TextView::set_justification | ( | Justification | justification | ) |

Sets the default justification of text in text_view.

Tags in the view's buffer may override the default.

Parameters

  justification | Justification.

## ◆ set_left_margin()

void Gtk::TextView::set_left_margin | ( | int | left_margin | ) |

Sets the default left margin for text in text_view.

Tags in the buffer may override the default.

Parameters

  left_margin | Left margin in pixels.

## ◆ set_overwrite()

void Gtk::TextView::set_overwrite | ( | bool | overwrite = `true` | ) |

Changes the Gtk::TextView overwrite mode.

Since gtkmm 2.4:

Parameters

  overwrite | `true` to turn on overwrite mode, `false` to turn it off.

## ◆ set_pixels_above_lines()

void Gtk::TextView::set_pixels_above_lines | ( | int | pixels_above_lines | ) |

Sets the default number of blank pixels above paragraphs in text_view.

Tags in the buffer for text_view may override the defaults.

Parameters

  pixels_above_lines | Pixels above paragraphs.

## ◆ set_pixels_below_lines()

void Gtk::TextView::set_pixels_below_lines | ( | int | pixels_below_lines | ) |

Sets the default number of pixels of blank space to put below paragraphs in text_view.

May be overridden by tags applied to text_view's buffer.

Parameters

  pixels_below_lines | Pixels below paragraphs.

## ◆ set_pixels_inside_wrap()

void Gtk::TextView::set_pixels_inside_wrap | ( | int | pixels_inside_wrap | ) |

Sets the default number of pixels of blank space to leave between display/wrapped lines within a paragraph.

May be overridden by tags in text_view's buffer.

Parameters

  pixels_inside_wrap | Default number of pixels between wrapped lines.

## ◆ set_right_margin()

void Gtk::TextView::set_right_margin | ( | int | right_margin | ) |

Sets the default right margin for text in the text view.

Tags in the buffer may override the default.

Parameters

  right_margin | Right margin in pixels.

## ◆ set_tabs()

void Gtk::TextView::set_tabs | ( | Pango::TabArray & | tabs | ) |

Sets the default tab stops for paragraphs in text_view.

Tags in the buffer may override the default.

Parameters

  tabs | Tabs as a Pango::TabArray.

## ◆ set_wrap_mode()

void Gtk::TextView::set_wrap_mode | ( | WrapMode | wrap_mode | ) |

Sets the line wrapping for the view.

Parameters

  wrap_mode | A Gtk::WrapMode.

## ◆ signal_insert_at_cursor()

Glib::SignalProxy< void,const Glib::ustring& > Gtk::TextView::signal_insert_at_cursor | ( |  | ) |

Slot Prototype:
  `void on_my_insert_at_cursor(const Glib::ustring& str)`

Flags: Run Last

## ◆ signal_populate_popup()

Glib::SignalProxy< void,Menu* > Gtk::TextView::signal_populate_popup | ( |  | ) |

Slot Prototype:
  `void on_my_populate_popup(Menu* menu)`

Flags: Run Last

## ◆ signal_set_anchor()

Glib::SignalProxy< void > Gtk::TextView::signal_set_anchor | ( |  | ) |

Slot Prototype:
  `void on_my_set_anchor()`

Flags: Run Last

## ◆ signal_set_scroll_adjustments()

Glib::SignalProxy< void,Adjustment*,Adjustment* > Gtk::TextView::signal_set_scroll_adjustments | ( |  | ) |

Slot Prototype:
  `void on_my_set_scroll_adjustments(Adjustment* hadjustment, Adjustment* vadjustment)`

Flags: Run Last

## ◆ starts_display_line()

bool Gtk::TextView::starts_display_line | ( | const TextBuffer::iterator& | iter | ) |

Determines whether iter is at the start of a display line.

See forward_display_line() for an explanation of display lines vs. paragraphs.

Parameters

  iter | A Gtk::TextIter.

Returns
  `true` if iter begins a wrapped line.

## ◆ window_to_buffer_coords()

void Gtk::TextView::window_to_buffer_coords | ( | TextWindowType | win,
|  | int | window_x,
|  | int | window_y,
|  | int & | buffer_x,
|  | int & | buffer_y
| ) |  | const

Converts coordinates on the window identified by win to buffer coordinates, storing the result in ( buffer_x, buffer_y).

Note that you can't convert coordinates for a nonexisting window (see set_border_window_size()).

Parameters

  win | A Gtk::TextWindowType except Gtk::TEXT_WINDOW_PRIVATE.
  window_x | Window x coordinate.
  window_y | Window y coordinate.
  buffer_x | Buffer x coordinate return location or `nullptr`.
  buffer_y | Buffer y coordinate return location or `nullptr`.

## Friends And Related Function Documentation

## ◆ wrap()

Gtk::TextView* wrap | ( | GtkTextView * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/textview.h